using System;
using System.Text;
using Unit4.CollectionsLib;
using Unit4.UtilsLib;
/**
 *   : 
 *   
 * @author  , '  
 * @version 14/5/2007
 */
namespace ConsoleApplicationVector1
{
    class Program
    {
        static void Main(string[] args)
        {
            Vector<int> v1 = new Vector<int>();
            v1.Add(-10);
            v1.Add(1);
            v1.Add(2);
            v1.Add(100);
            Console.WriteLine("Vector v1: " + v1);
            Console.WriteLine();

            Vector<int> v2 = new Vector<int>();
            Random rnd = new Random();
            for (int i = 1; i <= 10; i++)
            {
                v2.Add(rnd.Next(12));
            }
            Vector<int> v6 = GetKSmallestValues(v2, 6);
            Vector<int> v6b = GetKSmallestValues2(v2, 6);
            Console.WriteLine("Vector v2: " + v2);
            Console.WriteLine("6 smallest values of v2: " + v6);
            Console.WriteLine("and again: " + v6b);
            Console.WriteLine();

            Console.WriteLine(v2);
            v2.Del(1);
            v2.Del(5);
            v2.Del(v2.Length());
            Console.WriteLine("same vector without the first, sixth, and last element:");
            Console.WriteLine(v2);

            Console.WriteLine();
            for (int i = 1; i <= v2.Length(); i++)
                v2.Set(i, i);
            for (int i = 1; i <= v2.Length(); i++)
                Console.Write(v2.Get(i) + ",");
            Console.ReadLine();
        }
        //    
        public static Vector<int> GetKSmallestValues(Vector<int> vec, int k)
        {
            //  
            Vector<int> tmpVec = new Vector<int>();
            for (int i = 1; i <= vec.Length(); i++)
                tmpVec.Add(vec.Get(i));

            for (int i = 1; i <= k; i++)
            {
                int minPlace = i;
                for (int j = i; j <= tmpVec.Length(); j++)
                {
                    if (tmpVec.Get(j) < tmpVec.Get(minPlace))
                        minPlace = j;
                }
                int min = tmpVec.Get(minPlace);
                tmpVec.Set(minPlace, tmpVec.Get(i));
                tmpVec.Set(i, min);
            }

            Vector<int> resVec = new Vector<int>();
            for (int i = 1; i <= k; i++)
                resVec.Add(tmpVec.Get(i));

            return (resVec);
        }

        //    
        public static Vector<int> GetKSmallestValues2(Vector<int> vec, int k)
        {
            int[] a = new int[vec.Length()];

            for (int i = 0; i < vec.Length(); i++)
                a[i] = vec.Get(i + 1);

            for (int i = 0; i < k; i++)
            {
                int minPlace = i;
                for (int j = i; j < a.Length; j++)
                {
                    if (a[j] < a[minPlace])
                        minPlace = j;
                }
                int min = a[minPlace];
                a[minPlace] = a[i];
                a[i] = min;
            }

            Vector<int> resVec = new Vector<int>();
            for (int i = 0; i < k; i++)
                resVec.Add(a[i]);

            return (resVec);
        }
    }
}
