using System;
using System.Text;
using Unit4.CollectionsLib;
using Unit4.UtilsLib;
/**
 *   : 
 *   
 * @author  , '  
 * @version 14/5/2007
 */
namespace ConsoleApplicationVector1
{
    class Vector<T>
    {
        private Node<T> first;
        private Node<T> last;
        private int numValues;

        public Vector()
        {
            this.first = null;
            this.last = null;
            this.numValues = 0;
        }

        public void Add(T x)
        {
            Node<T> node = new Node<T>(x);

            if (this.first == null)
                this.first = node;
            else
                this.last.SetNext(node);
            this.last = node;

            this.numValues++;
        }

        public void Del(int place)
        {
            if (place == 1)
            {
                if (this.last == this.first)
                    this.last = null;
                this.first = this.first.GetNext();
            }
            else
            {
                Node<T> pos = this.first;

                for (int i = 1; i <= place - 2; i++)
                    pos = pos.GetNext();

                if (pos.GetNext() == this.last)
                    this.last = pos;
                pos.SetNext(pos.GetNext().GetNext());
            }

            this.numValues--;
        }

        public T Get(int place)
        {
            Node<T> pos = this.first;

            for (int i = 1; i < place; i++)
                pos = pos.GetNext();

            return (pos.GetInfo());
        }

        public void Set(int place, T x)
        {
            Node<T> pos = this.first;

            for (int i = 1; i < place; i++)
                pos = pos.GetNext();

            pos.SetInfo(x);
        }

        public int Length()
        {
            return (this.numValues);
        }

        public override String ToString()
        {
            String str = "";

            if (this.first != null)
            {
                Node<T> pos = this.first;

                while (pos != this.last)
                {
                    str = str + pos.GetInfo() + ",";
                    pos = pos.GetNext();
                }
                str = str + this.last.GetInfo();
            }
            return (str);
        }
    }
}
